import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { useCallback, useState } from 'react';
import PropTypes from 'prop-types';
import { debounce } from '@s-ui/js/lib/function/debounce.js';
import Injector from '@s-ui/react-primitive-injector';
import getCroppedImg from './utils/cropImage.js';
import ImageEditorDefault from './ImageEditorDefault.js';
import ImageEditorCropper from './ImageEditorCropper.js';
import ImageEditorSliders from './ImageEditorSliders.js';
import { baseClass, DEBOUNCING_TIME, DEFAULT_ASPECT, noop, getRotationDegrees } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";

var MoleculeImageEditor = function MoleculeImageEditor(_ref) {
  var _ref$aspect = _ref.aspect,
      aspect = _ref$aspect === void 0 ? DEFAULT_ASPECT : _ref$aspect,
      cropLabelIcon = _ref.cropLabelIcon,
      cropLabelText = _ref.cropLabelText,
      image = _ref.image,
      onChange = _ref.onChange,
      _ref$onCropping = _ref.onCropping,
      onCropping = _ref$onCropping === void 0 ? noop : _ref$onCropping,
      rotateLabelIcon = _ref.rotateLabelIcon,
      rotateLabelText = _ref.rotateLabelText,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? /*#__PURE__*/_jsx(ImageEditorDefault, {}) : _ref$children;

  var _useState = useState({
    x: 0,
    y: 0
  }),
      crop = _useState[0],
      cropSetter = _useState[1];

  var _useState2 = useState(0),
      rotation = _useState2[0],
      rotationSetter = _useState2[1];

  var _useState3 = useState(0),
      zoom = _useState3[0],
      zoomSetter = _useState3[1];

  var setCrop = debounce(cropSetter, DEBOUNCING_TIME);
  var setRotation = debounce(rotationSetter, DEBOUNCING_TIME);
  var setZoom = debounce(zoomSetter, DEBOUNCING_TIME);

  var cropCompleteHandler = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(croppedArea, croppedAreaPixels) {
      var rotationDegrees, _yield$getCroppedImg, croppedImageUrl, croppedImageBlobObject;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              rotationDegrees = getRotationDegrees(rotation);
              onCropping(true);
              _context.next = 4;
              return getCroppedImg(image, croppedAreaPixels, rotationDegrees);

            case 4:
              _yield$getCroppedImg = _context.sent;
              croppedImageUrl = _yield$getCroppedImg[0];
              croppedImageBlobObject = _yield$getCroppedImg[1];
              onChange(croppedImageUrl, croppedImageBlobObject);
              onCropping(false);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function cropCompleteHandler(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  var onCropComplete = useCallback(debounce(cropCompleteHandler, DEBOUNCING_TIME), [rotation, onCropping, image, onChange]);
  return /*#__PURE__*/_jsx("div", {
    className: baseClass,
    children: /*#__PURE__*/_jsx(Injector, {
      image: image,
      crop: crop,
      zoom: zoom,
      rotation: rotation,
      aspect: aspect,
      onCropChange: setCrop,
      onCropComplete: onCropComplete,
      onRotationChange: setRotation,
      onZoomChange: function onZoomChange(zoom) {
        return setZoom((zoom - 1) * 100);
      },
      rotateLabelIcon: rotateLabelIcon,
      rotateLabelText: rotateLabelText,
      cropLabelIcon: cropLabelIcon,
      cropLabelText: cropLabelText,
      onZoomSliderChange: function onZoomSliderChange(event, _ref3) {
        var value = _ref3.value;
        return setZoom(value);
      },
      onRotateSliderChange: function onRotateSliderChange(event, _ref4) {
        var value = _ref4.value;
        return setRotation(value);
      },
      children: children
    })
  });
};

MoleculeImageEditor.displayName = 'MoleculeImageEditor';
export default MoleculeImageEditor;
export { ImageEditorCropper as MoleculeImageEditorCropper, ImageEditorSliders as MoleculeImageEditorSliders };